#!/bin/bash
# fake_a_syslog.sh
# Simple script to interactivly prompt someone for details on faking a syslog message
#
# Version 0.1 SRM 08.02.2013 - Initial version 
# Version 0.2 SRM 31.07.2017 - Cleanup for release to internet 

# Check for root - need root to actually send the packet.
if [[ $UID -ne 0 ]]; then 
  echo "Error: $0 needs to be run as root in order to have direct access to the adapter.  Exiting."
#  exit 1
fi

echo "This will fake a syslog message.  Requirement is that this host be in the same net "
echo "as the syslog server, as we'll be spoofing the source address.  Spoofing will be dropped"
echo "by any firewalls as a protection.  If you must go through a firewall, then be sure to"
echo "insert this Host's IP as the source address when asked."

echo "From which source IP should the message appear to come from?  This should typically be the device that you're trying tofake a message from."
echo "Ex: 1.2.3.4"
read IPSRC

echo "Should this send by TCP or UDP?  Note that spoofing is only supported via UDP, so if you entered an IP other than an IP on this host, you must choose udp here."
echo "Ex: udp"
read PROTOCOL

echo "What source port would you like to come from? This can be any number above 1024 and can be chosen randomly"
echo "Ex: 54461" 
read SRCPORT

echo "What destination port would you like to send to?  This is typically port 514 for syslog messages, unles it's listening on a nonstandard port, like DeviceExpert (5140)"
echo "Ex: 514"
read DSTPORT

echo "Which server would you like to send to?  This can be a syslog server or one of the further receivers, example Netcool.  Remember this needs to be in the same network as your system if you're spoofing!"
echo "Ex: 192.168.0.1"
read IPDST

echo "What message would you like to send.  You will need to carefully specify the format here, otherwise it will not be interpreted correctly.  The format is typically: "
echo "<PRI> - a number which represents the severity and facility of the message.  See RFC3164 for how to determine this, or steal from a capture"
echo "DATE - in format MMM   X XX:XX:XX - note two spaces in front of single digit dates (Dec__9 vs Dec_10)"
echo "Hostname - this should be thrown away by the syslog server and replaced with the hostname as resovled from your spoofed source IP."
echo "Message contents - which are typically a processname[processid]: something"
echo "Here is an example of a message with a priority of <30> or "
echo "<30> dhcpd[28845]: DHCPINFORM from 1.2.3.4 via 3.4.5.6: not authoritative for subnet 1.2.3.0"
read MESSAGE

echo "Ok I will try to send a message from $IPSRC:$SRCPORT to $IPDST:$DSTPORT using $PROTOCOL.  Cross your fingers!!" 

./sendip -v -p ipv4 -is $IPSRC -p $PROTOCOL -us $SRCPORT -ud $DSTPORT -d "$MESSAGE" $IPDST

